#!/usr/bin/perl
#######################################
#
# Mysql table audit v 0.5 (2008) - BETA!!!!
#
# Author Marco Tusa 
# Copyright (C) 2001-2003, 2008
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#######################################


use visualization;
use commonfunctions;
use mysqldbcommon;
use ConfigIniSimple;

use strict;
use warnings;

#use Tk::DialogBox;

# $dialog = $main->DialogBox( -title   => "Register This Program", -buttons => [ "Register", "Cancel" ] );


use Time::Local;

use DBI;
use Getopt::Long;
$Getopt::Long::ignorecase = 0;


my $html = 0;
my $Param = {};
my $user = '';
my $pass = '';
my $help = '';
my $host = '' ;
my $outfile;
my $genericStatus = 2;
my $finalreport = '';
my @excludelist  ;
my @includelist ;
my @authorizedList ;
my $dsn;
my $conf = new ConfigIniSimple;
my $defaultfile;

$Param->{user}       = '';
$Param->{password}   = '';
$Param->{host}       = '';
$Param->{port}       = 3306;
$Param->{debug}      = 0;
$Param->{authorized}   = 'root'; 
$Param->{excludelist}  = '';
$Param->{includelist} = '';
$Param->{reset}       = 0;
$Param->{toDelTriggers} ='';
my $invalidator  = 0 ;

$Param->{appheader}.="\t=============================================================================\n";
$Param->{appheader}.="\t*****************************************************************************\n";
$Param->{appheader}.="\t\t\t\tAUDIT MySQL Procedure\n";
$Param->{appheader}.="\t*****************************************************************************\n";
$Param->{appheader}.="\t=============================================================================\n";
#$Param->{outfile};

################################
#INIZIALIZATION SECTION [START]#
################################
sub init()
{
    if(defined($defaultfile) && $defaultfile ne '' && $Param->{reset} == 0)
    {
        resetSettings($Param);
        
        $conf = loadIniObject($defaultfile);
        my $selected = loadSettingsFromIni($conf,$Param);


        if(defined($selected))
        {
        
            $host = defined($selected->{host})?$selected->{host}:'';
            $Param->{host} = defined($selected->{host})?$selected->{host}:'';
            $Param->{port} = defined($selected->{port})?$selected->{port}:'3306';
            $Param->{user} = defined($selected->{user})?$selected->{user}:'';
            $Param->{outfile} = defined($selected->{outfile})?$selected->{outfile}:undef;
            $outfile = defined($selected->{outfile})?$selected->{outfile}:'';
            $Param->{excludelist} = defined($selected->{excludelist})?$selected->{excludelist}:undef;
            $Param->{includelist} = defined($selected->{includelist})?$selected->{includelist}:undef;
            $Param->{invalidator} = 0;
            $invalidator = 0;
            #$Param->{password} = defined($selected->{password})?$selected->{password}:'';
            $Param->{authorized} =defined($selected->{authorized})?$selected->{authorized}:'root';    

        #my %bloks = %{keys(%{$conf})};
        }
        
    }

    $Param->{reset} = 0;
    
    if( $host eq '' )
    {
        $host = getHost();
    }
    $Param->{host} = &URLDecode($host);
    
    if( $Param->{port} eq '' || $Param->{port} eq '3306')
    {
        $Param->{port} = getPort($Param->{port});
    }
    

    if(defined $outfile && $outfile ne '')
    {
         $Param->{outfile} = URLDecode($outfile);
    }
    else
    {
        $outfile = promptUser("Please insert valid path and file name to use for output script","/tmp/audit.sql","/tmp/audit.sql");
         $Param->{outfile} = URLDecode($outfile);
         open FILEOUT, '>', $Param->{outfile} or die "Couldn't open $Param->{outfile} for writing: $!\n";
         close FILEOUT;
    }
    
    $dsn  = "DBI:mysql:host=$Param->{host};port=$Param->{port}";
    if(defined $Param->{user} && $Param->{user} ne ''){
            $user = "$Param->{user}";
    }
    else
    {
            $user = getUser();
            $Param->{user} = $user;
    }
    
    if(defined $Param->{password} && $Param->{password} ne ''){
            $pass = "$Param->{password}";
    }
    else
    {
            $pass = getPassword();
            $Param->{password} = $pass;
    }
    
    if(defined $Param->{authorized} && $Param->{authorized} eq 'root')
    {
            my $authorized = getAuthorizeFromPrompt($Param->{authorized});
            $Param->{authorized} = $authorized;
    }
    
    
    
    
    if( defined $Param->{outfile}){
    
        if (open FILEOUT, '>', $Param->{outfile}){
        }
    }
    
    #my $filexxx;
    #
    #if( defined $Param->{outfile}){
    #
    #    if (open ($filexxx, '>', $Param->{outfile})){
    #    }
    #    print $filexxx "\n aaaaaaa \n";
    #    close $filexxx;
    #}
    
    $Param->{invalidator} = $invalidator;
    
    $Param = getExcludeList($Param);
    $Param = getIncludeList($Param);
    
    $invalidator = $Param->{invalidator};
    while($invalidator > 1 || $invalidator ==0)
    {
        $Param = checkForLists($Param);
        $invalidator = $Param->{invalidator};    
        
    }
    
    
    
}
################################
#INIZIALIZATION SECTION [ENDS]#
################################

    

sub getInitialOk($)
{
    $Param = shift;
    system('clear');
    
    my $reportString = $Param->{appheader};
    $reportString .= "\t=============================================================================\n";
    $reportString .= "\t\t\t\t Procedure Settings\n";
    $reportString .= "\t=============================================================================\n";
    $reportString .= "\tHost = ".$Param->{host}."\n";
    $reportString .= "\tPort = ".$Param->{port}."\n";
    $reportString .= "\tUser = ".$Param->{user}."\n";
    $reportString .= "\t------------------------\n";
    $reportString .= "\tSQL generated file = ".$Param->{outfile}."\n";
    if(defined($Param->{excludelist}) && $Param->{excludelist} ne ''){
        $reportString .= "\tExclude list = ".getArrayAsComma($Param->{excludelist})."\n";
    }
    if(defined($Param->{includelist}) && $Param->{includelist} ne ''){
        $reportString .= "\tInclude List = ".getArrayAsComma($Param->{includelist})."\n";
    }
    $reportString .= "\tNot traced user(s) = ".$Param->{authorized}."\n";
    $reportString .= "\t=============================================================================\n";
    
    print $reportString;
    
    my $question .= "\tChoose:\n";
    $question .= "\t[1] Continue\n";
    $question .= "\t[2] Re insert all values\n\n";
    $question .= "\t[S] Save settings to file\n";
    $question .= "\t[0] EXIT\n";
    $question .= "\t=============================================================================\n";
    
    $genericStatus = promptUser($question,1,"1(default)|2|0");
    print "\n".$genericStatus;
    if($genericStatus eq '0')
    {
        exit(0);
    }
        
    return $genericStatus;
    
}

sub resetSettings($)
{
    $Param = shift;
    $host = '';
    $Param->{host} = '';
    $Param->{port} = '3306';
    $Param->{user} = '';
    undef($Param->{outfile});
    $outfile = '';
    undef($Param->{excludelist});
    undef($Param->{includelist});
    $Param->{invalidator} = 0;
    $invalidator = 0;
    $Param->{password} = '';
    $Param->{authorized} ='root';    
    $_=0;
    close FILEOUT;
    
    return $Param;
}


if (
    !GetOptions(
        'user|u:s'       => \$Param->{user},
        'password|p:s'   => \$Param->{password},
        'host|H:s'       => \$host,
        'port|P:i'       => \$Param->{port},
        'authorized|a:s'   => \$Param->{authorized},
        'outfile|o:s'    => \$outfile,
        'debug|e:i'      => \$Param->{debug},
        'excludelist|x:s' => \$Param->{excludelist},
        'includelist|i:s' => \$Param->{includelist},
        'help|h:s'       => \$help,
        'defaults-file:s'=>\$defaultfile,

    )
  )
{
    ShowOptions();
    exit(0);
}
else{
    init();
    while($genericStatus eq '2')
    {
        
        $genericStatus = getInitialOk($Param);
        if($genericStatus eq '0')
        {
            exit(0);            
        }
        elsif($genericStatus eq '2')
        {
            init();
            $Param = resetSettings($Param);
            $Param->{reset} = 2;
            
        }
        elsif($genericStatus eq 'S')
        {
            my $selected = {};
            my $defaultFile = promptUser("Defaults file",$defaultfile,$defaultfile);
            my $settingsName = promptUser("Settings name ",'','');

            $selected->{host} = $Param->{host};
            $selected->{port} = $Param->{port};
            $selected->{user} = $Param->{user};
            $selected->{outfile} = $Param->{outfile};
            $selected->{excludelist} = defined($Param->{excludelist})?getArrayAsComma($Param->{excludelist}):'';
            $selected->{includelist} = defined($Param->{includelist})?getArrayAsComma($Param->{includelist}):'' ;
            $selected->{password} = $Param->{password};
            $selected->{authorized} = $Param->{authorized};    
            
            saveSettings($selected,$defaultFile,$settingsName);
            $genericStatus=2;
            $genericStatus = getInitialOk($Param);
            
        }
        else
        {
            $genericStatus = getInitialOk($Param);
        }
        
    }

}

if ( $help ne '' ) {
    ShowOptions();
    exit(0);
}

if($Param->{debug}){
    debugEnv();
}

#
#my $username = &promptUser("Enter the username ","AA");
#print "Name= ".$username."\n";



##############################################################################################
# F U N C T I O N  S E C T I O N
# T O  B E C O M E S  O B J E C T  M E T H O D S
##############################################################################################

sub getAuthorizeFromPrompt($)
{
    my $authorized = shift;
    
    return $authorized = promptUser("Please type list comma separated\n of user that should *not* be traced ",$authorized,$authorized);
}



sub getAuthorizedList($)
{
    my $Param = shift ;  
    my @authorizedList  = @{$Param->{authorizedList}};
    my $strUserList = "";
    
    if(defined $Param->{authorizedList})
       {
	    for (my $i=0; $i < @authorizedList; $i++) {
		if ($authorizedList[$i] ne "") {
                    if($i > 0)
                    {
                        $strUserList = $strUserList." AND \@username NOT LIKE \"$authorizedList[$i]\"";
                    }
                    else
                    {
                        $strUserList = " \@username NOT LIKE \"$authorizedList[$i]\"";
                    }
                    
		}
		
	    }
            $strUserList = $strUserList. " AND \@username NOT LIKE '' "
            
	    
       }
    return \$strUserList;
}



sub createAuditSysTable($)
{
    my $Param = shift ;  
    my $dbh  = $Param->{dbh};
    
    my $cmd = "/*!40014 SET \@OLD_UNIQUE_CHECKS=\@\@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
    /*!40014 SET \@OLD_FOREIGN_KEY_CHECKS=\@\@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
    /*!40111 SET \@OLD_SQL_NOTES=\@\@SQL_NOTES, SQL_NOTES=0 */;";

    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", $cmd ," \n";
    }
    
    
    $cmd = "create database if not exists security;";
    my $sth = $dbh->prepare($cmd);
    $sth->execute();

    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", $cmd ," \n";
    }


    $cmd = "create table if not exists `security`.`SYS_AUDIT_MAINLOG`(
            `SYS_HISTOR_ID` CHAR(36) NOT NULL ,
            `SYS_HISTOR_SCHEMA` varchar(50) collate utf8_bin NOT NULL default '',
            `SYS_HISTOR_TABLE` varchar(200) collate utf8_bin default NULL,
            `SYS_HISTOR_OPERATION_TYPE` varchar(6) collate utf8_bin default NULL,
            `SYS_HISTOR_TIMESTAMP` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
            `SYS_HISTOR_USER` varchar(20) collate utf8_bin default NULL,
            `SYS_HISTOR_TERM` varchar(20) collate utf8_bin default NULL,
            `SYS_HISTOR_SESSION_ID` decimal(21,0) default NULL,
            PRIMARY KEY  (`SYS_HISTOR_ID`),
            INDEX `IDX_SCHEMA_TAB` USING HASH (`SYS_HISTOR_SCHEMA`,`SYS_HISTOR_TABLE`)
          ) ;\n";
          
#    $cmd = $cmd."/*!51001 ADD PARTITION COMMANDS */";      
          
    #$sth = $dbh->prepare($cmd);
    #$sth->execute();
    
    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", $cmd ," \n";
    }

    
    
    return $Param;
}





    

 
sub createAuditByTable($)
{
      my $Param = shift;  
      my $dbh  = $Param->{dbh};
      my %databases = %{$Param->{tables}};

    if((defined $Param->{authorized}) and ($Param->{authorized} ne "")){
       @authorizedList = split(/,/,join(',',$Param->{authorized}));
       $Param->{authorizedList}=\@authorizedList;
       $Param->{authorized}=${getAuthorizedList($Param)};
    }
    else
    {
        undef $Param->{authorizedList};
        undef $Param->{authorized};
    
    }
      

        my $alltables = "";
        my %locReport;

    foreach my $key (sort keys %databases)
    {
        my @tables = @{$databases{$key}};
        my $dimTable = '';

        my $cmd = "use ".$key;
        my $sth = $dbh->do($cmd);
        my $time = localtime;
	
        my %columnHash ;
        my @columTypeDim ;
	my $tblDirty = 0;
	
        #if (defined($Param->{outfile})){
        #    print FILEOUT "Starting on ", $time," \n";
        #}
        print "processing = $key [start] at $time \n";

        for (my $icounter = 0 ; $icounter <= $#tables; $icounter++)
        {
            my %columnHash ;
            

	    $dimTable = $tables[$icounter];
            
            #get table number of rows
            my $numberOfRows;
            my $audDb = $key."_audit";
            
            my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
            $mon = ++$mon;
            $year = $year+=1900;

#            print $audDb_bck . "\n";
           
           
            $cmd = "create database if not exists $audDb;";
            if (defined($Param->{outfile}))
            {
                print FILEOUT "\n", $cmd ," \n";
            }

#            $cmd = "SELECT COLUMN_NAME FROM information_schema.COLUMNS where table_schema='$key' and table_name='$dimTable'";
            $cmd = "SELECT COLUMN_NAME, Data_TYPE, NUMERIC_PRECISION, CHARACTER_MAXIMUM_LENGTH FROM information_schema.COLUMNS where table_schema='$key' and table_name='$dimTable'";

	    $sth = $dbh->prepare($cmd);
	    $sth->execute();

	    #my $recordSet = $sth->fetchrow_hashref();
	    
	    
	    #if (defined($recordSet))
	    #{
	      my $row = undef;
              my $newColumns = "";  
              my $oldColumns = "";
              
	      while ( $row = $sth->fetchrow_hashref() )
	      {
                my @columTypeDim ;
		$newColumns = $newColumns."NEW\.".$row->{'COLUMN_NAME'}.",";
		$oldColumns = $oldColumns."OLD\.".$row->{'COLUMN_NAME'}.",";
                
                $columTypeDim[0] = $row->{'Data_TYPE'};
                $columTypeDim[1] = $row->{'NUMERIC_PRECISION'};
                $columTypeDim[2] = $row->{'CHARACTER_MAXIMUM_LENGTH'};
                $columnHash{$row->{'COLUMN_NAME'}} = \@columTypeDim
	      }
	    #}
	    $sth->finish();

            $Param->{currentDb} = $key;
            $Param->{currentTable} = $dimTable;
            
            $Param->{tbColumnStatus} = \%columnHash;
            
            $tblDirty=0;
            $tblDirty = getTableStatus($Param);
            #0 = stay as it is ; 1 do backup ; 2 generate audit table;
            
            if($tblDirty == 0)
            {
                print $dimTable." [NOT MODIFIED]\n";
            }
            elsif($tblDirty == 1)
            {
                print $dimTable." [MODIFIED Table will be BACKUP with name(".$audDb.".".$dimTable."_".$hour."_".$min."_"."_".$mday."_".$mon."_".$year.")]\n";
            }
            elsif($tblDirty == 2)
            {
                print $dimTable." [NEW AUDIT on table ".$audDb." Table will be CREATED ]\n";
            }


            
            undef($Param->{tbColumns});
            
            if($tblDirty != 0 )
            {

                if($tblDirty == 1 )
                {
                    my $audDb_bck = $audDb.".".$dimTable."_".$hour."_".$min."_"."_".$mday."_".$mon."_".$year;

                    $cmd = "RENAME TABLE ".$audDb.".".$dimTable." TO ".$audDb_bck.";\n";
                    $cmd = $cmd."ALTER TABLE ".$audDb_bck." engine=myisam;\n";

                    if (defined($Param->{outfile}))
                    {
                        print FILEOUT "\n", $cmd ," \n";
                    }                    
                    
                }
        
                
                # Create Table for audit in same db same name  with security_aud postfix
                my $currentTableAud = $audDb.".".$dimTable;
                $cmd = "CREATE TABLE IF NOT EXISTS $currentTableAud select * from $key.$dimTable limit 0;";
                #$sth = $dbh->prepare($cmd);
                #$sth->execute();
                
                if (defined($Param->{outfile}))
                {
                    print FILEOUT "\n", $cmd ," \n";
                }
                
    
                $cmd = "alter TABLE $currentTableAud add (operation varchar(10), idmainlog char(36), recordtype char(3));\n";
                $cmd = $cmd."alter TABLE $currentTableAud add INDEX `IDX_AUDIT_MAINLOG` USING HASH (`idmainlog`);";

                #$sth = $dbh->prepare($cmd);
                #$sth->execute();
    
                if (defined($Param->{outfile}))
                {
                    print FILEOUT "\n", $cmd ," \n";
                }
    
    #!!!!!! CONTROLLARE 
                #$cmd = "alter TABLE $currentTableAud engine=myisam;";
                #if (defined($Param->{outfile}))
                #{
                #    print FILEOUT "\n", $cmd ," \n";
                #}
            
            }

#	    $sth = $dbh->prepare($cmd);
#	    $sth->execute();
#            $sth->finish();
            
            $Param->{currentdb}=$key;
            $Param->{audDb}=$audDb;
            $Param->{currentTable}=$dimTable;
            $Param->{currentNew}=$newColumns;
            $Param->{currentOld}=$oldColumns;
            
            #do the triggers
            createDeleteTrigger($Param);
            createUpdateTrigger($Param);
            createInsertTrigger($Param);
            
            
        }

        $time = localtime;
        #if (defined($Param->{outfile})){
        #    print FILEOUT "\n\nClosing on", $time," \n";
        #}
        print "\n\nprocessing = $key [end] at $time \n";
        #$sth = $dbh->do($cmd);
    }
        
        #my $currDb = $databases[$counter];
        #my $cmd = "use ".$currDb;
        
        
        my $cmd = "/*!40101 SET SQL_MODE=\@OLD_SQL_MODE */;
                /*!40014 SET FOREIGN_KEY_CHECKS=\@OLD_FOREIGN_KEY_CHECKS */;
                /*!40014 SET UNIQUE_CHECKS=\@OLD_UNIQUE_CHECKS */;";

        my $toDelTriggers = "  /*======================UNCOMMENT THIS SECTION TO REMOVE ALL THE CREATED TRIGGERS==================*/\n";
        $toDelTriggers = $toDelTriggers.$Param->{toDelTriggers};
        $cmd = $cmd."\n".$toDelTriggers." \n /* ### /*";

        if (defined($Param->{outfile}))
        {
            print FILEOUT "\n", $cmd ," \n";
        }
        
    return \$Param;
}

sub createDeleteTrigger($)
{

    my $Param = shift;
    
    my $db = $Param->{currentdb};
    my $table = $Param->{currentTable};
    my $useraut = $Param->{authorized};
    my $new = $Param->{currentNew};
    my $old = $Param->{currentOld};
    my $audDb = $Param->{audDb};
    my $toDelTriggers = $Param->{toDelTriggers};
    
    my $TriggerGet = {};
    
    my $fullTablename = $db.".".$table;
    
    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", "-- Delete Trigger for $table  [START]"," \n";
    }

    $Param->{methodToAudit} = "DELETE";
    
    $TriggerGet = triggerBodyReplace($Param);
    my $cmd ="";
    my $acstatment = $Param->{acstatment};
    my $existingTriggerName = $Param->{existingTriggerName};

    $toDelTriggers = $toDelTriggers."\n"."/* Drop trigger if exists $db\.aud_d_$table; /*";
    $Param->{toDelTriggers}=$toDelTriggers ;
    
    $cmd = "DELIMITER ##    
    ";
    if(defined $acstatment &&  $acstatment ne "")
    {
        $cmd = $cmd."\t /* WARNING EXISTING TRIGGER FOUND\n";
        $cmd = $cmd."\t TRIGGER NAME = $db\.$existingTriggerName\n";
        $cmd = $cmd."\t GOING TO DROP IT AND INCLUDE IN THE NEW ONE*/
        ";
        
        $cmd = $cmd." Drop trigger if exists $db\.$existingTriggerName##
        ";
    }
    
    $cmd = $cmd." Drop trigger if exists $db\.aud_d_$table##
            
            CREATE TRIGGER $db\.aud_d_$table
             BEFORE DELETE ON $fullTablename FOR EACH ROW
             BEGIN
                    SET \@username='';
                    SET \@id=UUID();
                    SET \@action='DELETE';
                    SET \@host='';
                    SET \@connectionid=0; 
                    
                    #select max(SYS_HISTOR_ID)  into \@counter from security.SYS_AUDIT_MAINLOG;

/*                    if \@counter IS NULL then   
			  SET \@counter=0;
		    end if;
            
                    set \@counter = \@counter+1;
                    
 */
                    SELECT SUBSTRING_INDEX(USER(),'\@',1) INTO \@username;
                    SELECT SUBSTRING_INDEX(USER(),'\@',-1) INTO \@host;
                    SELECT connection_id() into \@connectionid;
            
                    
                    if ($useraut) then
            
                            INSERT INTO security.SYS_AUDIT_MAINLOG VALUES(
                                       \@id, 
                                       '$db',
                                       '$fullTablename',
                                       \@action, 
                                       NULL, 
                                       \@username,
                                       \@host,  
                                       \@connectionid
                                       );
                    
            
                            INSERT INTO $audDb.$table values($old\@action,\@id,'OLD')\n;
                            
                    end if;\n";

                            #This block reports the previously existing triggers in to the new one [START]
                            if(defined $acstatment &&  $acstatment ne "")
                            {
                                $cmd = $cmd."\n".$existingTriggerName.":   ".$acstatment." ".$existingTriggerName.";"
                            }
                            #This block reports the previously existing triggers in to the new one [END]

                        $cmd = $cmd ."\n
                    /* if ($useraut) then
                            INSERT INTO $audDb.$table values($new\@action,\@counter,'NEW');
                    end if;
                    */
            
            ";

            $cmd = $cmd ."
            END##

            DELIMITER ;";
            
        if (defined($Param->{outfile})){
            
            print FILEOUT "\n", $cmd," \n";
            print FILEOUT "\n", "-- Delete Trigger for $table  [END]"," \n";
            
        }
            
            
    return \$Param;
}

sub createUpdateTrigger($)
{

    my $Param = shift;
    
    my $db = $Param->{currentdb};
    my $table = $Param->{currentTable};
    my $useraut = $Param->{authorized};
    my $new = $Param->{currentNew};
    my $old = $Param->{currentOld};
    my $audDb = $Param->{audDb};
    my $toDelTriggers = $Param->{toDelTriggers};
    
    my $TriggerGet = {};
    
    my $fullTablename = $db.".".$table;
    
    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", "-- Update Trigger for $table  [START]"," \n";
    }

       $Param->{methodToAudit} = "UPDATE";
    
    $TriggerGet = triggerBodyReplace($Param);
    my $cmd ="";
    my $acstatment = $Param->{acstatment};
    my $existingTriggerName = $Param->{existingTriggerName};
  
    $toDelTriggers = $toDelTriggers."\n"."/* Drop trigger if exists $db\.aud_u_$table; /*";
    $Param->{toDelTriggers}=$toDelTriggers ;
    
    $cmd = "DELIMITER ##
    
    ";
    if(defined $acstatment &&  $acstatment ne "")
    {
        $cmd = $cmd."\t /* WARNING EXISTING TRIGGER FOUND\n";
        $cmd = $cmd."\t TRIGGER NAME = $db\.$existingTriggerName\n";
        $cmd = $cmd."\t GOING TO DROP IT AND INCLUDE IN THE NEW ONE*/
        ";
        
        $cmd = $cmd." Drop trigger if exists $db\.$existingTriggerName##
        ";
    }
    $cmd = $cmd." Drop trigger if exists $db\.aud_u_$table##
            
            CREATE TRIGGER $db\.aud_u_$table
             BEFORE UPDATE ON $fullTablename FOR EACH ROW
             BEGIN
                    SET \@username='';
                    SET \@id=UUID();
                    SET \@action='UPDATE';
                    SET \@host='';
                    SET \@connectionid=0; 
                    SET \@authorizeduser='$useraut';

/*                    
                    select max(SYS_HISTOR_ID)  into \@counter from security.SYS_AUDIT_MAINLOG;
                    
                    if \@counter IS NULL then
			  SET \@counter=0;
		    end if;
*/
            
                    set \@counter = \@counter+1;
                    
                    SELECT SUBSTRING_INDEX(USER(),'\@',1) INTO \@username;
                    SELECT SUBSTRING_INDEX(USER(),'\@',-1) INTO \@host;
                    SELECT connection_id() into \@connectionid;
            
                    
                    if ($useraut) then
            
                            INSERT INTO security.SYS_AUDIT_MAINLOG VALUES(
                                       \@id, 
                                       '$db',
                                       '$fullTablename',
                                       \@action, 
                                       NULL, 
                                       \@username,
                                       \@host,  
                                       \@connectionid
                                       );
                    
            
                            INSERT INTO $audDb.$table values($old\@action,\@id,'OLD');
                    end if;
                    \n";
                            #This block reports the previously existing triggers in to the new one [START]
                            if(defined $acstatment &&  $acstatment ne "")
                            {
                                $cmd = $cmd."\n".$existingTriggerName.":   ".$acstatment." ".$existingTriggerName.";"
                            }
                            #This block reports the previously existing triggers in to the new one [END]
                            
                            $cmd = $cmd ."\n
                    if ($useraut) then
                            INSERT INTO $audDb.$table values($new\@action,\@id,'NEW');
                    end if;
            
            ";
            
            $cmd = $cmd ."
            END##

            DELIMITER ;";
            
        if (defined($Param->{outfile})){
            
            print FILEOUT "\n", $cmd," \n";
            print FILEOUT "\n", "-- UPDATE Trigger for $table  [END]"," \n";
            
        }
            
            
    return \$Param;
}


sub createInsertTrigger($)
{
    my $Param = shift;
    
    my $db = $Param->{currentdb};
    my $table = $Param->{currentTable};
    my $useraut = $Param->{authorized};
    my $new = $Param->{currentNew};
    my $old = $Param->{currentOld};
    my $audDb = $Param->{audDb};
    my $toDelTriggers = $Param->{toDelTriggers};
    
    my $TriggerGet = {}; 
    
    my $fullTablename = $db.".".$table;
    
    if (defined($Param->{outfile}))
    {
        print FILEOUT "\n", "-- Insert Trigger for $table  [START]"," \n";
    }

   $Param->{methodToAudit} = "INSERT";
    
    $TriggerGet = triggerBodyReplace($Param);
    my $cmd ="";
    my $acstatment = $Param->{acstatment};
    my $existingTriggerName = $Param->{existingTriggerName};

    $toDelTriggers = $toDelTriggers."\n"."/* Drop trigger if exists $db\.aud_i_$table; /*";
    $Param->{toDelTriggers}=$toDelTriggers ;

    $cmd = "DELIMITER ##
    
    ";
    if(defined $acstatment &&  $acstatment ne "")
    {
        $cmd = $cmd."\t /* WARNING EXISTING TRIGGER FOUND\n";
        $cmd = $cmd."\t TRIGGER NAME = $db\.$existingTriggerName\n";
        $cmd = $cmd."\t GOING TO DROP IT AND INCLUDE IN THE NEW ONE*/
        ";
        
        $cmd = $cmd." Drop trigger if exists $db\.$existingTriggerName##
        ";
    }
    $cmd = $cmd." Drop trigger if exists $db\.aud_i_$table##
            
            CREATE TRIGGER $db\.aud_i_$table
             BEFORE INSERT ON $fullTablename FOR EACH ROW
             BEGIN
                    SET \@username='';
                    SET \@id=UUID();
                    SET \@action='INSERT';
                    SET \@host='';
                    SET \@connectionid=0; 
                    SET \@authorizeduser='$useraut';
                    
                    select max(SYS_HISTOR_ID)  into \@counter from security.SYS_AUDIT_MAINLOG;
/*            
                    if \@counter IS NULL then
			  SET \@counter=0;
		    end if;
            
                    set \@counter = \@counter+1;
*/                    
                    SELECT SUBSTRING_INDEX(USER(),'\@',1) INTO \@username;
                    SELECT SUBSTRING_INDEX(USER(),'\@',-1) INTO \@host;
                    SELECT connection_id() into \@connectionid;
            
                    
                    if ($useraut) then
            
                            INSERT INTO security.SYS_AUDIT_MAINLOG VALUES(
                                       \@id, 
                                       '$db',
                                       '$fullTablename',
                                       \@action, 
                                       NULL, 
                                       \@username,
                                       \@host,  
                                       \@connectionid
                                       );
                        --    INSERT INTO $audDb.$table values($old\@action,\@id,'OLD');                                       
                    end if;\n
                    ";
                            #This block reports the previously existing triggers in to the new one [START]
                            if(defined $acstatment &&  $acstatment ne "")
                            {
                                $cmd = $cmd."\n".$existingTriggerName.":   ".$acstatment." ".$existingTriggerName.";"
                            }
                            #This block reports the previously existing triggers in to the new one [END]
                        
                            $cmd = $cmd ."\n
                    if ($useraut) then

                            INSERT INTO $audDb.$table values($new\@action,\@id,'NEW');
                    end if;
            
            ";

            
            $cmd = $cmd ."
            END##

            DELIMITER ;";
            
            
        if (defined($Param->{outfile})){
            
            print FILEOUT "\n", $cmd," \n";
            print FILEOUT "\n", "-- Insert Trigger for $table  [END]"," \n";
            
        }
            
            
    return \$Param;
}

sub triggerBodyReplace($)
{
   my $Param = shift;
    
    my $db = $Param->{currentdb};
    my $table = $Param->{currentTable};
    my $useraut = $Param->{authorized};
    my $new = $Param->{currentNew};
    my $old = $Param->{currentOld};
    my $audDb = $Param->{audDb};

    my $cmd ="";
    my $dbh  = $Param->{dbh};
    my $acstatment;
    my $existingTriggerName ;
    my $methodToAudit = $Param->{methodToAudit};
    my $tablePrefix = "aud_";
    
    if($methodToAudit eq "DELETE")
    {
        $tablePrefix = $tablePrefix."d_";
    }
    elsif($methodToAudit eq "UPDATE")
    {
        $tablePrefix = $tablePrefix."u_";
    }
    elsif($methodToAudit eq "INSERT")
    {
        $tablePrefix = $tablePrefix."i_";
    }

    $cmd = "SELECT TRIGGER_NAME, ACTION_STATEMENT FROM INFORMATION_SCHEMA.TRIGGERS T where trigger_schema='$db' and event_object_schema='$db' and event_object_table='$table' and action_timing='BEFORE' and EVENT_MANIPULATION='$methodToAudit' and TRIGGER_NAME !='$tablePrefix$table'";
    

    my $sth = $dbh->prepare($cmd);
    $sth->execute();

    #my $recordSet = $sth->fetchrow_hashref();
    
    
    #if (defined($recordSet))
    #{
      my $row = undef;
      
      while ( $row = $sth->fetchrow_hashref() )
      {
        $acstatment = $row->{'ACTION_STATEMENT'};
        $existingTriggerName = $row->{'TRIGGER_NAME'};
        
            if(defined $acstatment)
            {
                print "========================================================\n";
                print "WARNING AN EXISTING TRIGGER IS FOUND IN TABLE $db.$table with name $existingTriggerName\n";

                #print $cmd."\n";
                print "========================================================\n";
                $Param->{acstatment} = $acstatment ;
                $Param->{existingTriggerName} = $existingTriggerName;
    
            }
            
      }
    if(!defined $acstatment )
    {
        $Param->{acstatment} = undef; ;
        $Param->{existingTriggerName} = undef;
    }
      
    #}
    $sth->finish();
    return \$Param;
}







sub ShowOptions {
    print <<EOF;
Usage: audit
       user|u
       password|p
       host|H
       port|P
       outfile|o
       help|h
       authorized|a:s
       excludelist|x
       includelist|i

audit.pl --defaults-file=/mnt/d/work/mysql/programs/mysqltools/audit/settings.ini -u=root -p=mysql -H=127.0.0.1 -P=6610 -a=root,app_user -i=pddbu,test -o=/Users/marcotusa/work/mysql/engagements/accenture/19_10_2009/audit.sql


--help, -h
    Display this help message

--authorized|a User authorized that will *NOT* be traked

--host=HOSTNAME, -H=HOSTNAME
    Connect to the MySQL server on the given host
--user=USERNAME, -u=USERNAME
    The MySQL username to use when connecting to the server
--password=PASSWORD, -p=PASSWORD
    The password to use when connecting to the server
--port=PORT, -P=PORT
    The socket file to use when connecting to the server
--includelist|i comma separated list of databases
--exludelist|x comma separeted list of databases
--outfile=FULLPATH, -o=FULLPATH
    Create a report

EOF
}
################################
#INVOCATION SECTION     [START]#
################################

 my %databaseTablesMap;
 my %reports;
 my $dbh = get_connection($dsn, $user, $pass);
 $Param->{dbh}=$dbh;

 $Param = createAuditSysTable($Param);
 $Param = getDataBases($Param);
 $Param = getTables($Param);
 

 createAuditByTable($Param);
 



################################
#INVOCATION SECTION     [ENDS]#
################################

$Param->{dbh}->disconnect();
if( defined $Param->{outfile}){
    close FILEOUT;
}

exit(0);

